// VECTROR.CPP: Vector operations.
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "vector.h"

// Calculate the magnitude of the vector
double Mag(VECTOR *V)
{
  return sqrt(V->X * V->X + V->Y * V->Y + V->Z * V->Z);
}

// Subtract the two vectors
VECTOR Subtract(VECTOR *V1, VECTOR *V2)
{
  VECTOR D;
  D.X = V1->X - V2->X;
  D.Y = V1->Y - V2->Y;
  D.Z = V1->Z - V2->Z;
  return D;
}

// Cross multiply the two vectors V1 and V2
VECTOR Cross(VECTOR *V1, VECTOR *V2)
{
  VECTOR C;
  C.X = V1->Y * V2->Z - V2->Y * V1->Z;
  C.Y = V1->Z * V2->X - V2->Z * V1->X;
  C.Z = V1->X * V2->Y - V2->X * V1->Y;
  return C;
}

// Divide the scalar number into the vector V
VECTOR Divide(VECTOR *V, double Num)
{
  VECTOR Result;

  if (Num != 0) {
    Result.X = V->X / Num;
    Result.Y = V->Y / Num;
    Result.Z = V->Z / Num;
  }
  return Result;
}

void Normalize(VECTOR *V)
{
  double D = sqrt(V->X * V->X + V->Y * V->Y + V->Z * V->Z);
  if (D != 0) {
    V->X = V->X / D;
    V->Y = V->Y / D;
    V->Z = V->Z / D;
  }
}

// Calculates the dot product of the two vectors V1 and V2
double Dot(VECTOR *V1, VECTOR *V2)
{
  return V1->X * V2->X + V1->Y * V2->Y + V1->Z * V2->Z;
}


          
